var tmpl=`
<div ref="multipleTable">
  <gsb-dlgform  ref="dlgform" @dlgFormClick="onDlgFormClick"  :headTitle="headTitle" :metaData="formMetaData" :toolbar="toolbar">
    <slot></slot>
  </gsb-dlgform>
  <gsb-button-group @select="onToolbarClick" ikey="new" :btns="toolbar"></gsb-button-group>
  <el-table
     border="true"
     :data="data"
     tooltip-effect="dark"
     style="width: 100%"
     :height="tblHeight"
     :max-height="tblHeight"
     :header-cell-style="headerCellStyle"
     :highlight-current-row="singleSelect"
     @selection-change="handleSelectionChange"
     @current-change="handleCurrentChange">
     <el-table-column
       type="selection"
       width="30"
       v-if="!isSingleSelect">
     </el-table-column>
     <el-table-column v-if="isIndexed"
       label="序号"
       type="index"
       width="60">
     </el-table-column>
     <template v-for="(col, index) in columnMetaData">
       <template v-if="!col.isTmpl">
           <el-table-column
             :width="col.width"
             :label="col.label"
             :prop="col.prop"
             :formatter="colFormatter"
             :show-overflow-tooltip="col.isShowTip?col.isShowTip:false">
           </el-table-column>
       </template>
       <template v-if="col.isTmpl">
           <el-table-column
             fixed="right"
             :width="col.width"
             :label="col.label"
             :type="col.type"
             :show-overflow-tooltip="col.isShowTip?col.isShowTip:false">
             <template slot-scope="scope">
                 <slot v-if="col.isBtns" name="btns" :row="scope.row">
                    <el-button v-if="btn.isInRow" type="text" @click="rowClick(scope.row,btn.key,btn.title,$event)" v-for="btn in toolbar">{{formatBtn(scope.row,btn)}}</el-button>
                 </slot>
                 <slot v-else name="other" :row="scope.row">
                    <img width="30px" height="30px" :src="scope.row.headUrl"/>
                 </slot>
             </template>
           </el-table-column>
       </template>
     </template>
   </el-table>
   <gsb-pager ref="pagerRef" @pageChange="pageChanged"></gsb-pager>
 </div>
`
module.exports=
`{
   template:'${tmpl}',
   props:["tagkey","isIndexed","isLazy","bizCode","dataSource","colFormatter","headStyle","spaceHeight","isSingleSelect","isDataAuto","listMethod","deleteMethod","initMethod","createMethod","updateMethod"],
   data:function(){
     return {
       toolbar:[],
       data:this.dataSource?this.dataSource:[],
       singleSelect:this.isSingleSelect=="true"?true:false,
       columnMetaData:[],
       searchMetaData:[],
       formMetaData:[],
       headTitle:"",
       status:"common",
       multiSelect:null,
       currentSearchObj:null,
       cfgdata:"",
       tagkey:"",
     };
   },
   created:function(){
      this.fetchMetaData();
   },
   mounted:function(){
    if(this.isDataAuto){
        this.fetchData();
    }

   },
   computed:{
     tblHeight:function(){
         var wkh=$(this.$root.$refs.workbench.$el).height();
         console.log("xxxxxxxxxxxxxxxxxxxxxxxxx");
         console.log(wkh);
         console.log(this.spaceHeight);
         var m=wkh-(this.spaceHeight?Number(this.spaceHeight):0);
         console.log("table height======="+m);
         return  m;
     }
   },
   watch:{
      tagkey:function(v){
        if(v && v!=""){
          console.log(this.cfgdata);
          console.log(v);
          this.columnMetaData=null;
          this.columnMetaData=this.cfgdata.formlist[v.tagkey[0]];
          this.tagkey=v;
          this.fetchData();
        }
      }
   },
   methods:{
     h(d){
       alert(d);
     },
     formatBtn:function(row,btn){
       if(btn.falseText!="undefined"){
           if(row[btn.boolProp]==false){
              return btn.falseText;
           }else{
              return btn.title;
           }
       }else{
         return btn.title;
       }
     },
     buildQuery(qobj){
       var rtn={};
       if(qobj){
         rtn.search=qobj;
       }
       rtn.pageInfo={pageSize:this.$refs.pagerRef.pageInfo.pageSize,pageNo:this.$refs.pagerRef.pageInfo.currentPage};
       return rtn;
     },
     pageChanged(ps,cp){
       if(this.isDataAuto){
           this.fetchData();
       }else{
          this.$emit("pagechanged",ps,cp,this.currentSearchObj);
       }
     },
     setpageTotal(total){
        this.$refs.pagerRef.pageInfo.total=total;
     },
     fetchData:function(qobj){
       console.log(this.isLazy);
       if(this.isLazy){
         console.log("22222222222222222222222222222222222222");
         var self=this;
         var methodName=this.listMethod?this.listMethod:"getDetail";
         var url=this.getUrl(methodName);
         tagkey=this.tagkey;
         var qc=this.buildQuery(tagkey);
         console.log(qobj);
         console.log(qc);
         this.$root.showMask();
         console.log(url);
         this.$root.postReq(url,qc).then(d=>{
             console.log("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxzzzzzxxxx");
             console.log("3333333333333333333333333333333333333");
             console.log(d.data.rows);
             console.log(url);
             this.data=null;
             this.data=d.data.rows;
             this.$refs.pagerRef.pageInfo.total=d.data.count;
             this.$root.hideMask();
         });
       }
     },
     fetchMetaData(){
     console.log("CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC");
        var self=this;
        this.$root.getReq("/web/metaCtl/getUiConfig",{"biz":this.bizCode}).then(cfg=>{
           if(cfg){
             this.cfgdata=cfg.data;
             cfg.data.toolbar.forEach(s=>{
              self.toolbar.push(s);
             });
             self.columnMetaData=cfg.data.formlist[this.tagkey];
             console.log("grid init searchMetaData.......finished");
           }
        });
     },
     handleSelectionChange:function(val){
       this.multiSelect=val;
       this.$emit("multiSelect",val);
     },
     handleCurrentChange:function(row,oldrow){
       if(row){
         console.log(row.id);
         this.$emit("changeRow",row,oldrow);
       }
     },
     headerCellStyle:function(){
       return this.headStyle;
     },
     rowClick(row,key,t,e){
      console.log("row click....");
      if(key=="delete"){
          this.$confirm('此操作将删除当前记录, 是否继续?', '提示', {
           confirmButtonText: '确定',
           cancelButtonText: '取消',
           type: 'warning'
         }).then(() => {
           var self=this;
           var methodName=this.deleteMethod?this.deleteMethod:"delete";
           var url=this.getUrl(methodName);
           this.$root.postReq(url,{id:row.id}).then(rtn=>{
             console.log("delete ok");
              console.log(rtn.data);
              if(rtn.status==0){
                this.$message({
                  type: 'success',
                  message: '删除成功!'
                });
                this.fetchData();
              }
           }
          );
         }).catch(() => {
           this.$message({
             type: 'info',
             message: '已取消删除'
           });
         });
      }
      if(key=="edit"){
        this.$refs.dlgform.dialogFormVisible=true;
        this.$nextTick(()=>{
          this.status="edit";
          this.headTitle=t;
          this.$refs.dlgform.setInitData(row);
        });
      }
      else{
        this.headTitle=t;
        this.$emit("rowclick",row,key,e);
      }
     },
     onDlgFormClick:function(k,model){
       console.log(k);
       console.log(JSON.stringify(model));
       if(k=="save"){
          var methodName=null;
          if(this.status=="new"){
            methodName=this.createMethod?this.createMethod:"create";
          }
          if(this.status=="edit"){
            methodName=this.updateMethod?this.updateMethod:"update";
          }
          var url=this.getUrl(methodName);
          console.log(model);
          this.$root.postReq(url,model).then(d=>{
            console.log("new Instance..ok.....");
            if(d.status==0){
              if(this.status=="new"){
                  this.$message({
                    type: 'success',
                    message: '新增成功!'
                  });
              }
              if(this.status=="edit"){
                  this.$message({
                    type: 'success',
                    message: '修改成功!'
                  });
              }
              this.$refs.dlgform.setInitData({});
              this.$refs.dlgform.dialogFormVisible=false;
              this.status="common";
              this.fetchData();
            }
          });
          this.$emit("onsave",model);
       }
       if(k=="cancel"){
          this.$refs.dlgform.dialogFormVisible=false;
          this.$refs.dlgform.setInitData({});
          this.status="common";
       }

     },
     onToolbarClick:function(k,t){
       if(k=="new"){
         console.log("uuuuuuuuuuuuuuuuuuuuuuuu");
         this.headTitle=t;
         this.status="new";
         var methodName=this.initMethod?this.initMethod:"initNewInstance";
         const url = this.getUrl(methodName);
         console.log(url);
         console.log("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");
         this.$root.getReq(url,null).then(d=>{
           console.log("init new initNewInstance........");
           console.log(d);
           if(d.status==0){
              this.$refs.dlgform.dialogFormVisible=true;
              this.$nextTick(()=>{
                this.$refs.dlgform.setInitData(d.data);
              });
           }
         });
       }
       if(k=="delete"){
        /*需要检查多选值，如果没有多选值，那么无法删除*/
        if(this.multiSelect && this.multiSelect.length>0){
          var ids=this.multiSelect.map(r=>{
             return r.id;
          });
          this.$confirm('此操作将删除选中记录, 是否继续?', '提示', {
           confirmButtonText: '确定',
           cancelButtonText: '取消',
           type: 'warning'
         }).then(() => {
           const url = this.getUrl("bulkDelete");
           this.$root.postReq(url,ids).then(d=>{
               if(d.status==0){
                 this.$message({
                   type: 'success',
                   message: '删除成功!'
                 });
                 this.fetchData();
               }
           });
         }).catch(() => {
             this.$message({
               type: 'info',
               message: '已取消删除'
             });
         });

        }
       }else{
         this.$emit("toolbarclick",this.multiSelect,k);
       }

     },
     queryClick:function(qobj){
        this.isLazy=false;
        this.currentSearchObj=qobj;
        this.fetchData(qobj);
     },
     showDlgForm:function(){
       this.$refs.dlgform.dialogFormVisible=true;
     },
     hideDlgForm:function(){
       this.$refs.dlgform.dialogFormVisible=false;
     },
     setInitFormData:function(data){
       this.$nextTick(()=>{
         this.$refs.dlgform.setInitData(data);
       });
     }
   },
   vname:"gsb-formlist"
}`
